Figure1=figure(1);
set(Figure1,'DefaultTextInterpreter','latex');
clf;
distance =0:1000:30000;
if distance(1)==0 
    distance(1)=10;
end
%length(distance)
%pause;
    C2n = 10^(-15); % Refractive index, turbulence
    d_1 = 0.1; %pupil diameter of the transmit aperture
    d_2 = 0.1;  %pupil diameter of the receive aperture   
    lamda = 1550*10^(-9); % wavelenghth (m)
    k = 2*pi/lamda;
    a_loss = 0.443;
    range_near  =5 ;% transition range
    range_far  =0.5;
fraction_lower_near = zeros(1,length(distance));
fraction_upper_near = zeros(1,length(distance));
fraction_far_field = zeros(1,length(distance));
fraction_lower = zeros(1,length(distance));
fraction_upper = zeros(1,length(distance));



for n=1:length(distance)
    % Near field 
    
    d = distance(n);
    D_f = (pi*d_1*d_2/(4*lamda*d)).^2;
    %if D_f(1)<1
    %    disp(d);        
    %end
    % calculate lower bound by equation 26-27-28 of Shapiro 2003
    rytov2= 0.124*C2n*k^(7/6)*d^(11/6);
    D_rytov2 = @(x) 51.0*rytov2*D_f^(5/12)*(d_1.*x).^(5/3);
    func_E= @(x) (8*sqrt(D_f)/pi).*exp(-D_rytov2(x)./2).*(acos(x) - x.*sqrt(1-x.^2)).*besselj(1,4.*x*sqrt(D_f)); 
    E = integral(func_E,0,1); 
    fraction_lower_near(n) = E*exp(-a_loss*d/1000);
    % calculate upper bound by eq.16 Shapiro 2003
    upper_bound = min(1,D_f(1));
    fraction_upper_near(n)=upper_bound(1)*exp(-a_loss*d/1000);
    % calculate fraction far -field by eq. 18-19 of Shapiro 2003 and eq. 14
    % Shapiro 1974
    % 
    D_far= @(x) 1.09*k^2*C2n*d*(d_1.*x).^(5/3);
    func_E_far= @(x) (8*sqrt(D_f)/pi).*exp(-D_far(x)./2).*(acos(x) - x.*sqrt(1-x.^2)).*besselj(1,4.*x*sqrt(D_f)); 
    E_far = integral(func_E_far,0,1); 
    fraction_far_field(n) = E_far*exp(-a_loss*d/1000);   
    
    fraction_lower(n)=fraction_lower_near(n);
    fraction_upper(n)=fraction_upper_near(n);
    if (D_f(1)<=1+range_near)&&(D_f(1)>=1-range_far)
         fraction_lower(n)=(fraction_lower(n)+ fraction_far_field(n))/2;
         fraction_upper(n)=(fraction_far_field(n)+ fraction_upper_near(n))/2;
         % Checked already, no difference between the two ways of taking
         % average
        %fraction_lower(n)=sqrt(fraction_lower(n)* fraction_far_field(n));
        %fraction_upper(n)=sqrt(fraction_far_field(n)* fraction_upper_near(n));
    end
    if D_f(1)<1-range_far
        fraction_lower(n)=fraction_far_field(n);
        fraction_upper(n)=fraction_far_field(n);
    end
    
    
end

% Filter the drawing

% for n=1:length(distance)
%     d = distance(n);
%     D_f = (pi*d_1*d_2/(4*lamda*d)).^2;
%     if D_f(1)<1
%         
%     end
% end
% fid = fopen('Normalised_fraction_FSO_moderate_turbulence.txt','w');
% fprintf(fid,'!Turbulence \t%e\n',C2n );
% fprintf(fid,'!Distance  Distance  frac_lower  frac_upper   Frame_length\n');
% for n=1:length(distance)
%     fprintf(fid,'%.2f \t%.2f \t%e \t%e \t%d\n',distance(n)/1000, distance(n)/1000, fraction_lower(n),fraction_upper(n), 10000);
% end
% fclose(fid);
semilogy(distance/1000, fraction_upper_near,'k--+','LineWidth',1,'MarkerSize', 10, 'DisplayName','\gamma_{NF,UB}');hold on;
semilogy(distance/1000, fraction_lower_near,'k--o','LineWidth',1,'MarkerSize', 10, 'DisplayName','\gamma_{NF,LB}');hold on;
semilogy(distance/1000, fraction_far_field,'k-->','LineWidth',1,'MarkerSize', 8, 'DisplayName',' \gamma_{FF}');hold on;
semilogy(distance/1000, fraction_upper,'b-s','LineWidth',1,'MarkerSize', 18, 'DisplayName',' \gamma_{UB}');hold on;
semilogy(distance/1000, fraction_lower,'b-d','LineWidth',1,'MarkerSize', 18, 'DisplayName',' \gamma_{LB}');hold on;
set(gca,'fontsize',16)
title('Bounds of fraction $\gamma$','fontsize',20)
ylabel('Fraction $\gamma$ of collected photons','fontsize',20)
xlabel('Distance $L$ [km]','fontsize',20)

h=legend('show');
set(h,'FontSize',20);
%legend('Upper-bound','Lower-bound');
ylim([0.0001 1]);
xlim([0 14]);






